<!DOCTYPE html>
<html>

<head>
  <title>Vue School Chat Room</title>
  <script src="https://unpkg.com/vue"></script>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://unpkg.com/native-toast@2.0.0/dist/native-toast.css">
</head>

<body>
  <div id="chat" class="container">
    <h1>Vue School Chat Room</h1>
    
    <!-- Messages -->
    <div v-for="message in messages" class="card">
      <div class="card-body">
        <!-- nickname -->
        <h6 class="card-subtitle mb-2 text-muted">{{ message.nickname }}</h6>
        <!-- content -->
        <p v-if="message !== editingMessage" class="card-text">{{ message.text }}</p>
        <textarea v-else v-model="messageText" class="form-control"></textarea>

        <div v-if="message !== editingMessage">
          <a @click.prevent="deleteMessage(message)" href="#" class="card-link">delete</a>
          <a @click.prevent="editMessage(message)" href="#" class="card-link">edit</a>
        </div>
        <div v-else>
          <a @click.prevent="cancelEditing" href="#" class="card-link">cancel</a>
          <a @click.prevent="updateMessage" href="#" class="card-link">update</a>
        </div>
      </div>
    </div>

    <hr>
    
    <!-- New Message -->
    <form v-if="!editingMessage" @submit.prevent="storeMessage">
      <div class="form-group">
        <label>Message:</label>
        <textarea v-model="messageText" class="form-control"></textarea>
      </div>
      <div class="form-group">
        <label>Nickname:</label>
        <input v-model="nickname" class="form-control"/>
      </div>
      <button class="btn btn-primary">Send</button>
    </form>
  </div>

  <!-- The core Firebase JS SDK is always required and must be listed first -->
  <script src="https://www.gstatic.com/firebasejs/7.6.1/firebase-app.js"></script>

  <!-- TODO: Add SDKs for Firebase products that you want to use
    https://firebase.google.com/docs/web/setup#available-libraries -->
  <script src="https://www.gstatic.com/firebasejs/7.6.1/firebase-database.js"></script>

  <script>
    // Your web app's Firebase configuration
    var firebaseConfig = {
      apiKey: "",
      authDomain: "",
      databaseURL: "",
      projectId: "",
      storageBucket: "",
      messagingSenderId: "",
      appId: ""
    };

    // Initialize Firebase
    firebase.initializeApp(firebaseConfig);

    const database = firebase.database();    
    const messagesRef = database.ref('messages');
  </script>

  <script src="https://unpkg.com/native-toast@2.0.0/dist/native-toast.js"></script>

  <script>
    new Vue({
      el: "#chat",
      data: {
        messages: [],
        messageText: '',
        nickname: Math.random().toString(36).substring(2, 15) + Math.random().toString(36).substring(2, 15),
        editingMessage: null,
      },
      methods: {
        storeMessage () {
          if (this.messageText.length > 0) {
            messagesRef.push({ text: this.messageText, nickname: this.nickname });
            this.messageText = '';
          }
        },
        deleteMessage(message) {
          messagesRef.child(message.id).remove();
        },
        editMessage(message) {
          this.editingMessage = message;
          this.messageText = message.text;
        },
        cancelEditing() {
          this.editingMessage = null;
          this.messageText = '';
        },
        updateMessage() {
          messagesRef.child(this.editingMessage.id).update({text: this.messageText});
          this.cancelEditing();
        },
        showNotification(message, nickname, type) {
          if (nickname !== this.nickname) {
            nativeToast({
              message: message,
              position: 'south',
              timeout: 5000,
              type: type,
              rounded: true,
            })
          }
        }
      },
      created() {
        messagesRef.on('child_added', (snapshot) => { 
          this.messages.push({...snapshot.val(), id: snapshot.key});           
          this.showNotification(`New message by ${snapshot.val().nickname}`, snapshot.val().nickname, 'success');
        });
        messagesRef.on('child_removed', (snapshot) => { 
          const deletedIndex = this.messages.findIndex(msg => msg.id === snapshot.key);
          this.messages.splice(deletedIndex, 1);
          this.showNotification(`Message deleted by ${snapshot.val().nickname}`, snapshot.val().nickname, 'warning');
         });
         messagesRef.on('child_changed', (snapshot) => { 
          const changedMessage = this.messages.find(msg => msg.id === snapshot.key);
          changedMessage.text = snapshot.val().text;
          this.showNotification(`Message updated by ${snapshot.val().nickname}`, snapshot.val().nickname, 'info');
         });
      },
    })
  </script>
</body>
</html> 
